﻿//
// ConsoleCSharp
//
// Copyright (c) 2016 http://www.curict.com
// This software is released under the MIT License, see LICENSE.txt.
//

using System;
using System.Data;

namespace ConsoleCSharp
{
    class Program
    {
        static void Main(string[] args)
        {
            // 様々なデータ型で、データテーブルに列を追加
            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("col_Boolean", typeof(System.Boolean));
            dataTable.Columns.Add("col_Byte", typeof(System.Byte));
            dataTable.Columns.Add("col_Byte[]", typeof(System.Byte[]));
            dataTable.Columns.Add("col_Char", typeof(System.Char));
            dataTable.Columns.Add("col_DateTime", typeof(System.DateTime));
            dataTable.Columns.Add("col_Decimal", typeof(System.Decimal));
            dataTable.Columns.Add("col_Double", typeof(System.Double));
            dataTable.Columns.Add("col_Guid", typeof(System.Guid));
            dataTable.Columns.Add("col_Int16", typeof(System.Int16));
            dataTable.Columns.Add("col_Int32", typeof(System.Int32));
            dataTable.Columns.Add("col_Int64", typeof(System.Int64));
            dataTable.Columns.Add("col_SByte", typeof(System.SByte));
            dataTable.Columns.Add("col_Single", typeof(System.Single));
            dataTable.Columns.Add("col_String", typeof(System.String));
            dataTable.Columns.Add("col_TimeSpan", typeof(System.TimeSpan));
            dataTable.Columns.Add("col_UInt16", typeof(System.UInt16));
            dataTable.Columns.Add("col_UInt32", typeof(System.UInt32));
            dataTable.Columns.Add("col_UInt64", typeof(System.UInt64));

            // -------------------------------------------------------
            // NULLを設定して例外が発生するか調べる
            // -------------------------------------------------------
            DataRow row = dataTable.NewRow();
            //row["col_Boolean"] = null;   // 例外発生
            //row["col_Byte"] = null;      // 例外発生
            row["col_Byte[]"] = null;
            //row["col_Char"] = null;      // 例外発生
            //row["col_DateTime"] = null;  // 例外発生
            //row["col_Decimal"] = null;   // 例外発生
            //row["col_Double"] = null;    // 例外発生
            //row["col_Guid"] = null;      // 例外発生
            //row["col_Int16"] = null;     // 例外発生
            //row["col_Int32"] = null;     // 例外発生
            //row["col_Int64"] = null;     // 例外発生
            //row["col_SByte"] = null;     // 例外発生
            //row["col_Single"] = null;    // 例外発生
            row["col_String"] = null;
            //row["col_TimeSpan"] = null;  // 例外発生
            //row["col_UInt16"] = null;    // 例外発生
            //row["col_UInt32"] = null;    // 例外発生
            //row["col_UInt64"] = null;    // 例外発生


            // -------------------------------------------------------
            // NULLの判定
            // -------------------------------------------------------

            if (row.IsNull("col_String"))
            {
                // 表示される
                Console.WriteLine("IsNULLです。");
            }

            if (row["col_String"] == DBNull.Value)
            {
                // 表示される
                Console.WriteLine("DBNull.Valueです。");
            }

            if (row["col_String"] == null)
            {
                // 表示されない
                Console.WriteLine("nullです。");
            }

            Console.ReadLine();
        }
    }
}
